{
   MenC.fth
   Forth Menue System
   uses AutoW.fth
   uses MultiProcK.fth ??
   02.12.23 Christof Eberspaecher
}

!polls \ clear multitasking
%red %pen
IFDEF *Men*
   singletask
    menOrg org
    menLutPC lutPC !
    menLutOrg lutOrg !
    FORGET *Men* }
pub *Men*    PRINT" MenC.fth" ;

0 bytes menOrg
lutPC @ := menLutPC
lutOrg @ := menLutOrg
%plain

7 cogstop \ no VGA

100 value lWidth#
IFNDEF fedFile$
   32 bytes fedFile$ }

lWidth# 8 +  bytes menLine$

: getBlkLine \ get a line into menLine$
   lWidth# for
      fget menLine$ i + c!
   next
   \ $0000.0A0D \ crlf
   \ " GRAB" @
   0 menLine$ lWidth# + !
   \ 0 menLine$ lWidth# + !
;

: pri$ ( str -- ) \ print a string including backslash
   begin
   dup c@ while
      dup c@ emit
      1+
   repeat
   drop
;



: listLines \ list menue lines with fixed length
   " men.blk" fopen$ 0exit
   %green %pen
   crlf ." Menue:        fedFile$= " fedFile$ print$ crlf
   %plain
   begin
   _fread @ sdc@ while \ EOF ?
      getBlkLine
      menLine$ pri$  crlf
   repeat
   fclose
;


long choice

: scanLines \ scan for choice as starter
   0 menLine$ c!
   " men.blk" fopen$ 0exit
   begin
   _fread @ sdc@   menLine$ c@ 0= and while \ EOF ?
      _fread @ sdc@ choice @ = if
         getBlkLine
         menLine$ pri$ crlf
      then
      lWidth# _fread +!
   repeat
   fclose
;

{
: cpyWord {: src# dest# -- }
   begin
   src# c@ dup 32 > while
      dest# c!
      1 +to_src#  1 +to_dest#
   repeat
   drop
   \ 13  dest# c!
   0 dest# c!
; forgetLocals
}

: findComment ( str -- ) \ find backslash comment and end
   begin
   dup c@ while
      dup c@ 92 = if 0 swap c! exit then
      1+
   repeat
   drop
;

: evalKey
   nx' @ C@
   DUP   dup 92 <> and IF \ not NULL and not backslash
      nx' ++
   ELSE drop 0 ukey W~ THEN
;

: eval ( str -- ) \ evaluate
   $0D OVER DUP LEN$ + W! \ add return was $20
   nx' !
   ' evalKey ukey W!
   BEGIN
   GET$ DUP LEN$ WHILE
      NUMBER 0= IF
         @WORD ukey W~ CALL$
         ' evalKey ukey W!
      THEN
   REPEAT
   DROP
;


33 bytes menCom$

IFNDEF reload
: reload \ load the file of the editor
   !POLLS
   fedFile$ fopen$ if
      @file floads
   then
;
}

: men
   key drop
   begin
      listLines
      ukey w~
      %green %pen
      ." Choice? F=fedFile x=End X=End+Reload " wkey choice ! %plain
      choice @ 'x' = if ." End Menue" crlf exit then
      choice @ 'X' = if ." End Menue - Reload" crlf
         reload exit then
      choice @ 'F' = if
         ." fedFile$? " get$ fedFile$ $!
      then

      scanLines
      menLine$ c@ if
         menLine$ findComment
         menLine$ 2 + eval
         crlf
      then
   again
;

: menEd " men.fth" fedFile$ $! ;
: metEd " men.txt" fedFile$ $! ;
: testEd " test.fth" fedFile$ $! ;
: fedEd " fed.fth" fedFile$ $! ;
fedEd
